﻿using System;
using System.Windows.Forms;
using System.Diagnostics;
using System.Management;
using ServicosWin;

namespace Listar_Servicos_Ativos
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        string nomeServico = "";

        private void btnListarServicos_Click(object sender, EventArgs e)
        {
            ManagementClass management = new ManagementClass("Win32_Process");
            ManagementObjectCollection mCollection = management.GetInstances();

            foreach (ManagementObject process in mCollection)
            {
                ListViewItem novoListViewItem = new ListViewItem();

                novoListViewItem.Text = (process["ProcessId"].ToString());
                novoListViewItem.SubItems.Add((string)process["Name"]);
                novoListViewItem.SubItems.Add((string)process["ExecutablePath"]);

                try
                {
                    FileVersionInfo info = FileVersionInfo.GetVersionInfo((string)process["ExecutablePath"]);
                    novoListViewItem.SubItems.Add(info.FileDescription);
                }
                catch
                {
                    novoListViewItem.SubItems.Add("N/A");
                }

                lvServicosAtivos.Items.Add(novoListViewItem);
            }
        }

        private void btnParar_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(nomeServico))
            {
                MessageBox.Show("Informe o nome do serviço", "Nome do Servico", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else
            {
                try
                {
                    DialogResult resultado = MessageBox.Show("Deseja parar o serviço : " + nomeServico + " ?","Parar", MessageBoxButtons.YesNo, MessageBoxIcon.Question);

                    if (resultado == DialogResult.Yes) 
                    {
                        ServicosWin.ServicosWin.StopService(nomeServico, 3000);
                    }
                }
                catch(Exception ex)
                {
                    MessageBox.Show("Erro : " + ex.Message, "Parar Serviço", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void lvServicosAtivos_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                nomeServico = lvServicosAtivos.SelectedItems[0].SubItems[1].Text;
            }
            catch
            {
                nomeServico = "";
            }
        }
    }
}
