﻿using System;
using System.Windows.Forms;
using System.ServiceProcess;
using Microsoft.Win32;

namespace Tratando_Servicos
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnListarServicos_Click(object sender, EventArgs e)
        {
            //Declarando a classe ServiceController e preenchendo um array com todos os serviços 
            //do windows usando o método GetServices()
            ServiceController[] services = ServiceController.GetServices();

            //Criando o cabeçalho com o nome das colunas no ListView
            MontaColunasListView();

            //percorre a relação de serviços e exibe no listview
            foreach (ServiceController service in services)
            {
                try
                {   //cria instância do ListViewItem
                    ListViewItem novoListViewItem = new ListViewItem();
                  
                    //obtendo nome e status do serviço
                    novoListViewItem.Text = service.ServiceName.ToString();
                    novoListViewItem.SubItems.Add(service.Status.ToString());
                   
                    //obtendo detalhes do serviço
                    RegistryKey regKey1 = Registry.LocalMachine.OpenSubKey("SYSTEM\\CurrentControlSet\\services\\" + service.ServiceName);
                    novoListViewItem.SubItems.Add(regKey1.GetValue("ImagePath").ToString());
                    novoListViewItem.SubItems.Add(regKey1.GetValue("Description").ToString());
                    regKey1.Close();
                    //exibindo as informações
                    lvServicos.Items.Add(novoListViewItem);
                }
                catch (Exception ex)
                {
                    Console.WriteLine(ex.Message);
                }
            }
        }

        //Monta Coluna no ListView
        private void MontaColunasListView()
        {
            lvServicos.Columns.Add("Nome", 250, HorizontalAlignment.Left);
            lvServicos.Columns.Add("Status", 100, HorizontalAlignment.Left);
            lvServicos.Columns.Add("Localização", 500, HorizontalAlignment.Left);
            lvServicos.Columns.Add("Descrição", 500, HorizontalAlignment.Left);

        }
    }
}
